import numpy as np
import pandas as pd
from sklearn.linear_model import LinearRegression
from sklearn.model_selection import train_test_split

from src.utils.config import REGRESSION_FILE, RESOURCES_DIR
from src.utils.printers import print_df, print_regressor_results

# TODO - TASK C
CHUNKS = 100
MIN_CHUNK_SIZE = 1000
MAX_CHUNK_SIZE = 1000000


# Computes the RMSE of the model
def compute_rmse(y_test, y_pred):
    # TODO - TASK A
    return None


# Computes the MAE of the model
def compute_mae(y_test, y_pred):
    # TODO - TASK A
    return None


# Computes the R-squared score of the model
def compute_r2_score(y_test, y_pred):
    # TODO - TASK A
    return None


# Evaluates the performance of a regressor by manually computing stuff...
def evaluate_regressor_dumb(y_test, y_pred):
    rmse = compute_rmse(y_test, y_pred)
    mae = compute_mae(y_test, y_pred)
    r_squared = compute_r2_score(y_test, y_pred)

    return rmse, mae, r_squared


# Evaluates the performance of a regressor using code written by others...
def evaluate_regressor_smart(y_test, y_pred):
    # TODO - TASK B
    rmse = None
    mae = None
    r_squared = None

    return rmse, mae, r_squared


# Evaluates the performance of a regressor
def evaluate_regressor(y_test, y_pred, mode='dumb'):
    if mode is 'dumb':
        rmse, mae, r_squared = evaluate_regressor_dumb(y_test, y_pred)
    elif mode is 'smart':
        rmse, mae, r_squared = evaluate_regressor_smart(y_test, y_pred)
    else:
        return None, None, None

    return rmse, mae, r_squared


# Plots the evolution of the RMSE when the dataset size varies
def plot_rmse_evolution(X, y, chunks, min_chunk_size, max_chunk_size):
    # TODO - TASK C
    pass


# Performs a regression on a sample dataset
def perform_regression():
    # Load the dataset from the resources folder
    dataset = pd.read_csv(RESOURCES_DIR + "/" + REGRESSION_FILE, dtype=np.float64)

    # Take a look at the first entries of the dataset
    print_df(dataset.head())

    # Extract the features from the dataset
    X = dataset.iloc[:, :-1]
    # print_df(X.head())

    # Extract the labels from the dataset
    y = dataset.iloc[:, -1:]
    # print_df(y.head())

    # Split the data into a training set and a test set with a 80-20 ratio
    X_train, X_test, y_train, y_test = train_test_split(X, y, test_size=0.2, random_state=42)

    # Build a linear regressor
    regressor = LinearRegression()

    # Fit data from the training set to the regressor
    regressor.fit(X_train, y_train)

    # Make predictions on the test set
    y_pred = regressor.predict(X_test)

    # Evaluate the model using y_pred and y_test and print the results
    mode = 'dumb'
    rmse, mae, r_squared = evaluate_regressor(y_test, y_pred, mode)
    print_regressor_results(rmse, mae, r_squared, mode)

    mode = 'smart'
    rmse, mae, r_squared = evaluate_regressor(y_test, y_pred, mode)
    print_regressor_results(rmse, mae, r_squared, mode)

    plot_rmse_evolution(X, y, CHUNKS, MIN_CHUNK_SIZE, MAX_CHUNK_SIZE)
